voronoi = require "voronoi"

function love.load()
	love.window.setMode(1000, 800)

	points_list = {}
	points_update = {}

	X0 = 50
	X1 = 950
	Y0 = 50
	Y1 = 750
	NUMPOINT = 100

	--Point that share the exact same coordinates can cause problems; adding a random decimal is a quick fix.
	for i = 1,NUMPOINT do
		points_list[i] = {x = math.random(X0,X1) + math.random(),y = math.random(Y0,Y1) + math.random()}
		points_update[i] = {dx = math.random(-2,2), dy = math.random(-2,2)}
	end
end

function love.draw()
	vertex, segments = voronoi(points_list, X0, Y0, X1, Y1)
	
	--Update point positions
    for i = 1,#points_list do
        points_list[i].x =  points_list[i].x + points_update[i].dx
        if points_list[i].x < X0 then
            points_list[i].x = X0
            points_update[i].dx = -1*points_update[i].dx
        end
        if points_list[i].x > X1 then
            points_list[i].x = X1
            points_update[i].dx = -1*points_update[i].dx
        end
        
        points_list[i].y =  points_list[i].y + points_update[i].dy
        if points_list[i].y < Y0 then
            points_list[i].y = Y0
            points_update[i].dy = -1*points_update[i].dy
        end
        if points_list[i].y > Y1 then
            points_list[i].y = Y1
            points_update[i].dy = -1*points_update[i].dy
        end
        
        love.graphics.setColor(0,255,0,255)
        love.graphics.circle("fill", points_list[i].x,points_list[i].y, 5)
    end

    --Draw the vertex and line segments
	for i = 1, #vertex do
		love.graphics.setColor(0,0, 255,255)
		love.graphics.circle("fill",vertex[i].x,vertex[i].y, 5)
	end
	for i = 1,#segments do
        if segments[i].done then
        	love.graphics.setColor(255,0,0, 255)
        	love.graphics.line(segments[i].startPoint.x,segments[i].startPoint.y,segments[i].endPoint.x,segments[i].endPoint.y)
        end    
    end
end